/* Kishimot's SCHeduler ver 0.06 */

#include <time.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <dirent.h>
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
 
typedef enum {
	ALL, FULL, DAY, WEEK, MONTH, MONTH30, SCHEDIT, HELP, ERROR
} MODE;

char *youbi[]= { "","","","","","","" };

int
compareDirectryEntry(char *s1,char *s2){
	if(strncmp(s1,s2,12)>0) return 1;
	return 0;
}

void
freeall(char **list){
	char **listbk;
	listbk=list;
	while(1){
		if(strncmp("end",*(list),3)==0) {
			free(*list);
			break;
		}
		free(*list);
		list++;
	}
	free(listbk);
}

void directrySort(char **ls,int entnum){
	int flag,i;
	char *swapbuf;
	
	while(1){
		flag=0;
		for(i=0;i<entnum;i++){
			if(compareDirectryEntry(*(ls+i),*(ls+i+1))==1){
				swapbuf=*(ls+i);
				*(ls+i)=*(ls+i+1);
				*(ls+i+1)=swapbuf;
				flag=1;
			}
		}
		if(flag==0)break;
	}
}

char **
dirlist(char *s){
	char **ls;
	DIR *dp;
	struct direct *dir;
	int entnum=0;

	ls = (char **)malloc(sizeof(char **)*(2));

	if((dp=opendir(s))==NULL){
		fprintf(stderr,"can't open %s\n",s);
		closedir(dp);
		exit(1);
	}

	while((dir = readdir(dp))!= NULL){
		if(dir->d_ino ==0) continue;
		if(strcmp(dir->d_name,"..")==0) continue;
		if(strcmp(dir->d_name,".")==0) continue;
		if(strcmp(dir->d_name,"holiday")==0) continue;

		ls = (char **)realloc(ls,sizeof(char **)*(entnum+2));
		*(ls+entnum) = strdup(dir->d_name);
		entnum++;
	}
	closedir(dp);
	directrySort(ls,entnum-1);

	*(ls+entnum) = strdup("end");
	
	return ls;
}

int
getWeekNumber(int yyyy,int mm,int dd){
	if((mm==1)||(mm==2)){
		yyyy--;
		mm+=12;
	}
	return (yyyy+yyyy/4-yyyy/100+yyyy/400+(13*mm+8)/5 + dd) % 7;
}

int
getLengthOfMonth(int yyyy,int mm){
	int l[]= { 0,31,28,31,30,31,30,31,31,30,31,30,31 };
	int leap;

	leap = yyyy%4 == 0 && yyyy%100 != 0 || yyyy%400==0;

	if(mm==2) return l[2]+leap;
	else      return l[mm];
}

void
showHelp(){
	printf("ksch [-aAdwmMsh] [yyyymmdd|mmdd|mm|dd]\n\n");
	printf("  -a                    ʹߤΥ塼ɽ\n");
	printf("  -A                    塼ɽ\n");
	printf("  -d [yyyymmdd|mmdd|dd] Υ塼ɽ\n");
	printf("  -w [yyyymmdd|mmdd|dd] ޤཱུΥ塼ɽ\n");
	printf("  -m [yyyymmdd|yyyymm|mm] ޤΥ塼ɽ\n");
	printf("  -M [yyyymmdd|yyyymm|mm] ޤΥ塼30ɽ\n");
	printf("  -e [yyyymmdd|mmdd|dd] Υ塼Խ\n");
	printf("  -h                    إפɽ\n");
}

void printDayItem(char *baseDir,char *filename){
	FILE *fp;
	char path[BUFSIZ],buf[BUFSIZ],sbuf[6];
	int yyyy,mm,dd;

	sprintf(path,"%s/%s",baseDir,filename);
	if((fp=fopen(path,"r"))==NULL){
		fprintf(stderr,"can't open %s\n",path);
		exit(1);
	}

	strncpy(sbuf,filename,4);
	yyyy=atoi(sbuf);
	strncpy(sbuf,filename+4,2);
	sbuf[2]='\0';
	mm=atoi(sbuf);
	strncpy(sbuf,filename+6,2);
	sbuf[2]='\0';
	dd=atoi(sbuf);

	printf("%04d/%02d/%02d(%s) -------------------\n",
		yyyy,mm,dd,youbi[getWeekNumber(yyyy,mm,dd)]);

	while(fgets(buf,BUFSIZ,fp)!=NULL){
		printf("           %s",buf);
	}
	fclose(fp);
}

void
showAll(char *baseDir,int yyyy,int mm,int dd){
	char **list,**listbk,fn[16];
	int flag=0;

	/* Fixed By k_ogi@ta2.so-net.ne.jp */
	list = listbk =dirlist(baseDir);
	sprintf(fn,"%04d%02d%02d.sch",yyyy,mm,dd);

	flag=0;
	while(1){
		if(strncmp("end",*(list),3)==0) break;
		if(strncmp((*list),fn,13)>=0) {
			printDayItem(baseDir,*list); 
			flag=1;
		}
		list++;
	}
	if(flag==0){
		printf("%04d/%02d/%02dʹߤͽϤޤ\n",yyyy,mm,dd);
	}
	freeall(listbk);
}

void
showDay(char *baseDir,int yyyy,int mm,int dd){
	char **list,**listbk,fn[16];
	int flag;

	list = listbk = dirlist(baseDir);
	sprintf(fn,"%04d%02d%02d.sch",yyyy,mm,dd);

	flag=0;
	while(1){
		if(strncmp("end",*(list),3)==0) break;
		if(strncmp((*list),fn,13)==0){
			printDayItem(baseDir,*list); 
			flag=1;
		}
		list++;
	}
	if(flag==0){
		printf("%04d/%02d/%02dͽϤޤ\n",yyyy,mm,dd);
	}
	freeall(listbk);
}


void
prevDay(int *yyyy,int *mm,int *dd){
	(*dd)--;

	if(*dd < 1){
		(*mm)--;
		if(*mm < 1){
			*mm=12;
			(*yyyy)--;
		}
		*dd=getLengthOfMonth(*yyyy,*mm);
	}
}


void
nextDay(int *yyyy,int *mm,int *dd){
	(*dd)++;
	if(*dd > getLengthOfMonth(*yyyy,*mm)){
		*dd=1;
		(*mm)++;
		if(*mm > 12){
			*mm=1;
			(*yyyy)++;
		}
	}
}

void
getFirstDayOfWeek(int *yyyy,int *mm,int *dd){
	int dn,i;

	dn=getWeekNumber(*yyyy,*mm,*dd);

	for(i=0;i<dn;i++){
		prevDay(yyyy,mm,dd);
	}
}

void
showWeek(char *baseDir,int yyyy,int mm,int dd){
	char **list,**listStart,fn[16];
	int flag,day,lastDay;

	list = listStart = dirlist(baseDir);
	getFirstDayOfWeek(&yyyy,&mm,&dd);

	flag=0;
	for(day=0;day<7;day++){
		sprintf(fn,"%04d%02d%02d.sch",yyyy,mm,dd);
		nextDay(&yyyy,&mm,&dd);
		list=listStart;
		while(1){
			if(strncmp("end",*(list),3)==0) break;
			if(strncmp((*list),fn,13)==0){
				printDayItem(baseDir,*list); 
				flag=1;
			}
			list++;
		}
	}

	if(flag==0){
		printf("νͽϤޤ\n");
	}
	freeall(listStart);
}

void
showMonth(char *baseDir,int yyyy,int mm){
	char **list,**listStart,fn[16];
	int flag,day,lastDay;

	list =  listStart = dirlist(baseDir);

	lastDay = getLengthOfMonth(yyyy,mm);

	flag=0;
	for(day=1;day<=lastDay;day++){
		sprintf(fn,"%04d%02d%02d.sch",yyyy,mm,day);
		list=listStart;
		while(1){
			if(strncmp("end",*(list),3)==0) break;
			if(strncmp((*list),fn,13)==0){
				printDayItem(baseDir,*list); 
				flag=1;
			}
			list++;
		}
	}
	if(flag==0){
		printf("%04d/%02dͽϤޤ\n",yyyy,mm);
	}
	freeall(listStart);
}

void
setLine(char *line,char *buf,int pos){
	int i;

	i=0;
	while(1){
		if(buf[i]=='\0') break;
		if(i>9)break;
		line[pos+i]=buf[i];
		if (((unsigned char)buf[i] & 0x80) != 0){
			if(i>8){
				line[pos+i]=' ';
				break;
			}
			i++;
			line[pos+i]=buf[i];
		}
		i++;
	}
}

void
setWeekLine(char *baseDir,char *filename,char *line1,char *line2,char *line3,int pos) {
	FILE *fp;
	char path[BUFSIZ],buf[BUFSIZ],buf2[14];
	int lineCount,len;

	sprintf(path,"%s/%s",baseDir,filename);
	if((fp=fopen(path,"r"))==NULL){
		fprintf(stderr,"can't open %s\n",path);
		exit(1);
	}

	lineCount = 0;
	while(fgets(buf,BUFSIZ,fp)!=NULL){
		len=strlen(buf)-1;
		buf[len]='\0';
		strncpy(buf2,buf,12); buf2[12]='\0';
		if(lineCount == 0){
			setLine(line1,buf2,pos);
		} else if(lineCount == 1){
			setLine(line2,buf2,pos);
		} else if(lineCount == 2){
			setLine(line3,buf2,pos);
		} else {
			break;
		}
		lineCount++;
	}
	fclose(fp);
}

void
showMonth30(char *baseDir,int yyyy,int mm){
	char **list,**listStart,fn[16];
	int i,day,week,lastDay,weekStart;
	char line1[82],line2[82],line3[82];

	list =  listStart = dirlist(baseDir);
	lastDay = getLengthOfMonth(yyyy,mm);
	weekStart = getWeekNumber(yyyy,mm,1);

	printf("%04dǯ%02d\n",yyyy,mm);
#ifdef COLOR
	printf("\033[31m    \033[m                                              \033[31m    \033[m\n");
#else
	printf("                                                      \n");
#endif
	for(i=0;i<weekStart;i++){ printf("           "); }
	
	for(i=0;i<80;i++) line1[i]=' ';
	for(i=0;i<80;i++) line2[i]=' ';
	for(i=0;i<80;i++) line3[i]=' ';
	line1[10]=line1[21]=line1[32]=line1[43]=line1[54]=line1[65]='|';
	line2[10]=line2[21]=line2[32]=line2[43]=line2[54]=line2[65]='|';
	line3[10]=line3[21]=line3[32]=line3[43]=line3[54]=line3[65]='|';

	line1[80]= line2[80]=line3[80]='\0';

	week=weekStart;
	for(day=1;day<=lastDay;day++){

		sprintf(fn,"%04d%02d%02d.sch",yyyy,mm,day);
		list=listStart;
		while(1){
			if(strncmp("end",*(list),3)==0) break;
			if(strncmp((*list),fn,13)==0) {
				setWeekLine(baseDir,fn,line1,line2,line3,week*11); 
			}
			list++;
		}
		if((week==6)||(day==lastDay)){
	/* Fixed By k_ogi@ta2.so-net.ne.jp */
#ifdef COLOR
			if(week==6)	printf("\033[31m--- %02d ---\033[m\n",day);
			else			printf("--- %02d ---\n",day);
#else
			printf("--- %02d ---\n",day);
#endif
			printf("%s\n",line1); 
			printf("%s\n",line2); 
			printf("%s\n",line3); 
			week=0;
			for(i=0;i<80;i++) line1[i]=' ';
			for(i=0;i<80;i++) line2[i]=' ';
			for(i=0;i<80;i++) line3[i]=' ';
			line1[10]=line1[21]=line1[32]=line1[43]=line1[54]=line1[65]='|';
			line2[10]=line2[21]=line2[32]=line2[43]=line2[54]=line2[65]='|';
			line3[10]=line3[21]=line3[32]=line3[43]=line3[54]=line3[65]='|';
			line1[80]= line2[80]=line3[80]='\0';
#ifdef COLOR
		} else if(week==0){
			printf("\033[31m--- %02d ---\033[m+",day);
			week++;
#endif
		}else{
			printf("--- %02d ---+",day);
			week++;
		}
	}
	printf("\n");
	freeall(listStart);
}

void
editSchedule(char *baseDir,char *editor,int yyyy,int mm,int dd){
	char sysbuf[BUFSIZ];

	sprintf(sysbuf,"%s %s/%04d%02d%02d.sch",editor,baseDir,yyyy,mm,dd);
	system(sysbuf);
}

int 
dayConv(char *s,MODE *mode,int *yyyy,int *mm,int *dd){
	char buf[9],*sbuf;
	int m,d;
	if(strlen(s)==8){
		strncpy(buf,s,4); buf[4]='\0'; *yyyy= atoi(buf);
		strncpy(buf,s+4,2); buf[2]='\0'; *mm= atoi(buf);
		strncpy(buf,s+6,2); buf[2]='\0'; *dd= atoi(buf);
	}else if(strlen(s)==6){
		strncpy(buf,s,4); buf[4]='\0'; *yyyy= atoi(buf);
		strncpy(buf,s+4,2); buf[2]='\0'; *mm= atoi(buf);
		*dd=1;
	}else if(strlen(s)==4){
		strncpy(buf,s,2); buf[2]='\0'; 
		m = atoi(buf);
		if(m<*mm) (*yyyy)++;
		*mm=m; 
		strncpy(buf,s+2,2); buf[2]='\0'; *dd= atoi(buf);
	}else if(strlen(s)==2){
		if((*mode==MONTH)||(*mode==MONTH30)){
			m = atoi(s);
			if(m<*mm) (*yyyy)++;
			*mm=m; 
			*dd=1; 
		}else{
			d = atoi(s);
			if(d<*dd) (*mm)++;;
			*dd=d;
			if(*mm > 12) {
				*mm = 1;
				(*yyyy)++;
			}
		}
	}
	if((*mm<1)||(*mm>12)||(*dd<1)||(*dd>getLengthOfMonth(*yyyy,*mm))){
		*mode=ERROR;	
	}

}


void
opt(int ac,char *av[],MODE *mode,int *yyyy,int *mm,int *dd){
	switch(ac){
		case 1:
			*mode = ALL;
			break;
		case 2:
			if(strcmp(av[1],"-a")==0)      *mode = ALL; 
			else if(strcmp(av[1],"-h")==0) *mode = HELP; 
			else if(strcmp(av[1],"-A")==0) *mode = FULL; 
			else if(strcmp(av[1],"-d")==0) *mode = DAY; 
			else if(strcmp(av[1],"-w")==0) *mode = WEEK; 
			else if(strcmp(av[1],"-m")==0) *mode = MONTH; 
			else if(strcmp(av[1],"-M")==0) *mode = MONTH30; 
			else if(strcmp(av[1],"-e")==0) *mode = SCHEDIT; 
			else                           *mode = ERROR; 
			break;
		case 3:
			if(strcmp(av[1],"-d")==0)      *mode = DAY; 
			else if(strcmp(av[1],"-w")==0) *mode = WEEK; 
			else if(strcmp(av[1],"-m")==0) *mode = MONTH; 
			else if(strcmp(av[1],"-M")==0) *mode = MONTH30; 
			else if(strcmp(av[1],"-e")==0) *mode = SCHEDIT; 
			else                           *mode = ERROR; 
			if(dayConv(av[2],mode,yyyy,mm,dd)==-1) *mode = ERROR; 
			break;
		default:
				*mode = ERROR; 
			break;
	}
}


int
main(int ac,char *av[]){
	MODE mode;
	int yyyy,mm,dd;
	time_t tdata;
	struct tm *tst;
	char *bdir, baseDir[256];
	char *editor, *pager;

	tdata=time(NULL);
	tst=localtime(&tdata);

	if(NULL != (bdir = getenv("KSCHDIR"))){
		strcpy(baseDir,bdir);
	}else{
		sprintf(baseDir,"%s/.ksch",getenv("HOME"));
	}

	if(NULL == (editor = getenv("EDITOR"))) editor="jvim";
	if(NULL == (pager = getenv("PAGER"))) pager="less";

	// default 
	dd=tst->tm_mday;
	mm=(tst->tm_mon)+1;
	yyyy=tst->tm_year+1900;

	opt(ac,av,&mode,&yyyy,&mm,&dd);
	if(mode==ERROR){
		fprintf(stderr,"bad option");
		exit(1);
	}

	if(mode==HELP){
		showHelp();
	} else if(mode==ALL){
		showAll(baseDir,yyyy,mm,dd);
	} else if(mode==FULL){
		showAll(baseDir,0000,00,00);
	} else if(mode==DAY){
		showDay(baseDir,yyyy,mm,dd);
	} else if(mode==WEEK){
		showWeek(baseDir,yyyy,mm,dd);
	} else if(mode==MONTH){
		showMonth(baseDir,yyyy,mm);
	} else if(mode==MONTH30){
		showMonth30(baseDir,yyyy,mm);
	} else if(mode==SCHEDIT){
		editSchedule(baseDir,editor,yyyy,mm,dd);
	}
}
